/*
  undrdr 
  Drive Undrunk

  paolo lulli 2007 (paolo@lulli.net)
*/

#include "config.h"
#include<stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MAXSTRING 256

void usage();
void version(void);


struct input_data interactive_init(void);

double get_d(char *prompt);
char * get_s(char *prompt);

struct input_data{
	double gr; 
	double weight; 
	double volume; 
	char *sex;
}data;


double alcohol_tax(double gr, double weight, double volume, char *sex);
int check_data(struct input_data in); 

/************
    main
*************/


int
main (int argc, char *argv[])
{
  	int c;
  	double tax;
	char  *s_gr, *s_weight, *s_volume; 
	double gr, weight, volume = 0; 
	char *sex = "M";

  while ((c = getopt (argc, argv, "uVp:ig:w:v:s:")) != -1)
    {
      switch (c)
        {
        case 'V':
          version ();
          break;
	
        case 'g':
          s_gr = optarg;
	  gr = strtod(s_gr, NULL);
	  data.gr = strtod(s_gr, NULL);
#ifdef DEBUG
          printf ("	 Prova con parametro g=[%s]\n", s_gr);
          printf ("	 Prova con parametro g=[%f]\n", gr);
          printf ("	 Prova con parametro g=[%f]\n", data.gr);
#endif
          break;

        case 'w':
          s_weight = optarg;
	  weight = strtod(s_weight, NULL);
	  data.weight = strtod(s_weight, NULL);
#ifdef DEBUG
          printf ("	 Prova con parametro w=[%s]\n", s_weight);
          printf ("	 Prova con parametro w=[%f]\n", weight);
          printf ("	 Prova con parametro w=[%f]\n", data.weight);
#endif
          break;


        case 'v':
          s_volume = optarg;
	  volume = strtod(s_volume, NULL);
	  data.volume = strtod(s_volume, NULL);
#ifdef DEBUG
          printf ("	 Prova con parametro v=[%s]\n", s_volume);
          printf ("	 Prova con parametro v=[%f]\n", volume);
          printf ("	 Prova con parametro v=[%f]\n", data.volume);
#endif
          break;

        case 's':
          sex = optarg;
          data.sex = optarg;
#ifdef DEBUG
          printf ("	 Prova con parametro s=[%s]\n", sex);
          printf ("	 Prova con parametro s=[%s]\n", data.sex);
#endif
          break;

        case 'u':
		usage();
          exit (0);

        case 'i':
		data = interactive_init();
          break;

        case 'p':
          printf ("	 Prova con parametro p=[%s]\n", optarg);

          break;
        }
    }
#ifdef DEBUG
	printf("INIT performed, processing data...\n");
#endif

	
	if ( (check_data(data)) == 0 ){
		tax = alcohol_tax(data.gr, data.weight, data.volume, data.sex);
		printf("a. tax = [%f]\n", tax );
	} else {
		printf("Data malformed, skipping...\n");
		usage();
	}
}



/********************************************************************************/


void
version (void)
{
  printf ("	 Copyright paolo lulli 2007 (paolo@lulli.net) \n");
}
  

void
usage(){
  char * prog_name = "undrdr";
  printf("Usage:\n");
  printf("%s: -i\tInteractive\n", prog_name);
  printf("%s: -w <weight> -g <degree>  -v <liters> -s <M|F>\t Uninteractive \n", prog_name);
}

double
alcohol_tax(double gr, double weight, double volume, char *sex){
	double sex_coeff = 0.7;
	double tax;
	if(strcmp("F", sex)){
		sex_coeff = 0.6;
	}
	tax = 0.0076 * gr * (volume/weight) * sex_coeff;
	return tax;

}


struct input_data 
interactive_init(void){

	struct input_data  in_data;
	in_data.gr = 0;
	in_data.weight=0; 
	in_data.volume=0; 

	in_data.gr = get_d("Insert Percent:\n");
	in_data.weight = get_d("Insert your weight:\n");
	in_data.volume = get_d("Insert how much you drank:\n");
	in_data.sex = get_s("Insert your sex [M/F]:\n");
#ifdef DEBUG
	printf("gr=[[%f]]\n", in_data.gr);
	printf("volume=[[%f]]\n", in_data.volume);
	printf("weight=[[%f]]\n", in_data.weight);
	printf("sex=[[%s]]\n", in_data.sex);
#endif
	return in_data;

}

int 
check_data(struct input_data in){
	if(0 == in.gr){
		return(-1);	
	}
	if(0 == in.volume){
		return(-1);	
	}
	if(0 == in.weight){
		return(-1);	
	}
	return(0);
}
